#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen      
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  Aqua
#property indicator_color5  Magenta
#property indicator_width1  2      
#property indicator_width2  2 
#property indicator_width3  2 

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                MaPeriod        = 4;
extern int                MaShift         = 0;
extern ENUM_MA_METHOD     MaMethod        = MODE_EMA;
extern ENUM_APPLIED_PRICE MaPrice         = 0;
extern bool               alertsOn        = false;
extern bool               alertsOnCurrent = false;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = true;
extern bool               alertsNotify    = false;
extern bool               alertsEmail     = false;
extern string             soundFile       = "alert2.wav";
extern int                arrowthickness  = 1;

//
//
//
//
//

double ma[];
double maUa[];
double maUb[];
double arrUp[];
double arrDn[];
double trend[];

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
  {
   IndicatorBuffers(6);
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,maUa);
   SetIndexBuffer(2,maUb); 
   SetIndexBuffer(3,arrUp);  SetIndexStyle(3,DRAW_ARROW,0,arrowthickness); SetIndexArrow(3,233);
   SetIndexBuffer(4,arrDn);  SetIndexStyle(4,DRAW_ARROW,0,arrowthickness); SetIndexArrow(4,234);
   SetIndexBuffer(5,trend); 
   IndicatorShortName(timeFrameToString(TimeFrame)+" Ma Slope");
return(0);
}
int deinit() { Comment(""); return(0); }

//
//
//
//
//

int start()
{  
      int i,limit,counted_bars=IndicatorCounted();

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          limit=MathMax(Bars-counted_bars,3*TimeFrame/Period());
      
      //
      //
      //
      //
      //
      
      if (trend[limit]==-1) CleanPoint(limit,maUa,maUb);              
      for(i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         ma[i]    = iMA(NULL,TimeFrame,MaPeriod,MaShift,MaMethod,MaPrice,y);
         maUa[i]  = EMPTY_VALUE;
         maUb[i]  = EMPTY_VALUE;
         trend[i] = trend[i+1];
           if (ma[i]>ma[i+1]) { trend[i]= 1; Comment("\n SWAPLONG = ",DoubleToStr(MarketInfo(Symbol(),MODE_SWAPLONG),2),"   SWAPSHORT = ",DoubleToStr(MarketInfo(Symbol(),MODE_SWAPSHORT),2),"\n BUY TREND ",DoubleToStr(iClose(NULL,TimeFrame,y),_Digits));}
           if (ma[i]<ma[i+1]) { trend[i]=-1; Comment("\n SWAPLONG = ",DoubleToStr(MarketInfo(Symbol(),MODE_SWAPLONG),2),"   SWAPSHORT = ",DoubleToStr(MarketInfo(Symbol(),MODE_SWAPSHORT),2),"\n SELL TREND ",DoubleToStr(iClose(NULL,TimeFrame,y),_Digits));}
           if (trend[i]==-1)  PlotPoint(i,maUa,maUb,ma);
            
           //
           //
           //
           //
           //
      
           arrUp[i] = EMPTY_VALUE;
           arrDn[i] = EMPTY_VALUE;
           if (trend[i]!= trend[i+1])
           if (trend[i] == 1)
                 arrUp[i] = ma[i] - iATR(NULL,0,20,i)/2;
           else  arrDn[i] = ma[i] + iATR(NULL,0,20,i)/2;
        } 
        
        //
        //
        //
        //
        //
      
       if (alertsOn)
       {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar));
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("sloping up");
        else  doAlert("sloping down");       
      }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

      
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(TimeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ma  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
      

